const path = require('path');
const download = require('download-git-repo');
const list = require('../../config/list.json')
const ora = require('ora')
const fs = require('fs')

function getOptions(template) {
    // 默认从gitlab中prefix地址中取tempalte，如果配置文件存在,走配置文件
    let clone = true;
    let prefix = 'gitlab:gitlab.tydicdev.com:ZT/BASE/front-end/template/';
    let url = `${prefix}${template}`;
    if (list[template]) {
        clone = list[template].isPrivate;
        !clone && (url = `${list[template].path}`);
    }
    ;
    return {
        clone,
        url
    }

}

module.exports = function (template, createPath) {
    const temp = path.join(createPath, '.download-temp');
    return new Promise((resolve, reject) => {
        // 这里可以根据具体的模板地址设置下载的url，注意，如果是git，url后面的branch不能忽略
        let {url, clone} = getOptions(template);
        const spinner = ora(`正在下载项目模板：${template}`)
        spinner.start();
        download(url,
            temp,
            {clone},
            (err) => {
                if (err) {
                    spinner.fail();
                    reject(err)
                } else {
                    spinner.succeed()
                    // 下载的模板存放在一个临时路径中，下载完成后，可以向下通知这个临时路径，以便后续处理
                    resolve(temp)
                }
            });
    })
}